Morph subclass: #ClassChooserMorph
	instanceVariableNames: 'class label button frame '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 21:58'!
chooseClass

	|menu list packages pkg pkgMenu catMenu |
	packages _ Dictionary new.
	SystemOrganization categories asSortedCollection do: [:cat |
		pkg _ (cat asString findTokens: #( $- )) first.
		(packages includesKey: pkg)
			ifFalse: [ packages at: pkg put: OrderedCollection new].
		(packages at: pkg) add: cat].

	menu _ MenuMorph new.
	packages keys asSortedCollection do: [:eachPkg |
		pkgMenu _ MenuMorph new.
		(packages at: eachPkg) asSortedCollection do: [: cat |
			catMenu _ self menuForCategory: cat.
			pkgMenu add: (self wordsFrom: cat asString)
					subMenu: catMenu ].
		"pkgMenu add: (self wordsFrom: eachPkg asString)
				subMenu: pkgMenu."
		menu add: eachPkg subMenu: pkgMenu ].



"
	list _ SystemOrganization categories asSortedCollection.
	list do: [:each|
		menu add: (self wordsFrom: each asString) subMenu: (self menuForCategory: each)].
"
	menu popUpAt: button center x @ (self bottom + 5) forHand: World activeHand! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:30'!
class: aClass
	| classToSet |
	classToSet _ aClass.

	frame ifNotNil: [
		(frame currentSide = #class)
		& (aClass isKindOf: Metaclass) not
			ifTrue: [ classToSet _ aClass class ]].

	class = classToSet ifTrue: [^self].
	class _ classToSet.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	label contents: (self wordsFrom: class name asString).
	self fitMorphs.

	frame ifNotNil: [
		frame selectClass: class]! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:21'!
fitMorphs
	button extent: (label height @ label height) * 2//3.
	button position: self left @ self top + (label height - button height // 2).
	label position: (button right + (button width // 3)) @ self top.
	self extent: label bottomRight - self position! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 22:06'!
frame: aMorph
	frame _ aMorph! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:34'!
handlesMouseDown: evt
	^ true
! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:20'!
initialize
	super initialize.
	self color: Color gray.
	self addMorph: (button _ TriangleButtonMorph new
				target: self;
				selector: #chooseClass)
	! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:46'!
labelColor
	^Color white! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:23'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 12! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:41'!
menuForCategory: categoryName

	|menu list |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ SystemOrganization listAtCategoryNamed: categoryName.
	list asSortedCollection do: [:each|
		menu add: (self wordsFrom: each asString) selector: #class: argument: (Smalltalk classNamed: each)].
	^menu
! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:35'!
mouseDown: evt
	self chooseClass! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 08:33'!
selectedClass
	^class! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:09'!
wordsFrom: camelCase
	^SyntaxElementMorph wordsFrom: camelCase
! !


Morph subclass: #ElementPaletteMorph
	instanceVariableNames: 'elements variables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementPaletteMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 22:20'!
addElement: anElement
	|maxWidth|
	self addMorph: anElement.
	elements isEmpty
		ifTrue:[ anElement position: self position + (2@2)]
		ifFalse: [ anElement position: self position + (2@(elements last bottom + 2)) ].
	elements add: anElement.
	self height: (elements last bottom + 2) - (self top).
	maxWidth _ elements last width + 4.
	elements do: [:element|
		maxWidth _ (element width + 4) max: maxWidth ].
	self width: maxWidth! !

!ElementPaletteMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:44'!
initialize
	super initialize.
	elements _ OrderedCollection new.
	color _ Color gray.! !

!ElementPaletteMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 22:50'!
isPartsBin

	^ true
! !

!ElementPaletteMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:46'!
rootForGrabOf: aMorph
	"I act like a parts bin; answer a new copy of the morph being extracted."

	| v |

	v _ aMorph ownerThatIsA: SyntaxElementMorph.
	v ifNotNil: [
		(v isKindOf: ArgumentElementMorph)
			ifTrue: [^v owner fullCopy].
		^v fullCopy].

	^nil! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ElementPaletteMorph class
	instanceVariableNames: ''!

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:31'!
basics
	^self new
		addElement: StepElementMorph new;
		addElement: ReturnElementMorph new;
		addElement: PrimitiveElementMorph new;
		addElement: BlockElementMorph new;
		addElement: (ObjectElementMorph new label: 'self');
		addElement: (ObjectElementMorph new label: 'super');
		addElement: (ObjectElementMorph new label: 'true');
		addElement: (ObjectElementMorph new label: 'false');
"		addElement: (ObjectElementMorph new label: 'thisContext');"
		addElement: (LiteralElementMorph new);
"		addElement: (MessageElementMorph new selector: #new);"
		addElement: MessageElementMorph new assign;
		addElement: MessageElementMorph new yesNo
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:55'!
classVarsFor: aClass
	| pal |
	pal _ self new.
	aClass classVarNames asSortedCollection do: [:vname|
		pal addElement: (ObjectElementMorph new label: vname asString) ].

	pal addElement: ((StringMorph contents: ' inherited:' font: self labelFont) color: self labelColor).

	(aClass allClassVarNames reject: [:iv | aClass classVarNames includes: iv]) asSortedCollection do: [:vname|
		pal addElement: (ObjectElementMorph new label: vname asString) ].

	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 22:42'!
classes
	| pal |
	pal _ self new.
	Smalltalk classNames asSortedCollection do: [:class|
		pal addElement: (ObjectElementMorph new label: class asString) ].
	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:20'!
currentPackageClasses: aClass
	| pal packages pkg |
	pkg _ ((SystemOrganization categoryOfElement: aClass name asSymbol) asString findTokens: #( $- )) first.
	packages _ self packageClassesDict.
	pal _ self new.
	(packages at: pkg) asSortedCollection do: [:class|
		pal addElement: (ObjectElementMorph new label: class asString) ].
	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 22:41'!
globals
	| pal |
	pal _ self new.
	(Smalltalk keys reject: [:key| Smalltalk classNames includes: key]) asSortedCollection do: [:global|
		pal addElement: (ObjectElementMorph new label: global asString) ].
	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:53'!
instVarsFor: aClass
	| pal |
	pal _ self new.
	aClass instVarNames asSortedCollection do: [:vname|
		pal addElement: (ObjectElementMorph new label: vname asString) ].

	pal addElement: ((StringMorph contents: ' inherited:' font: self labelFont) color: self labelColor).

	(aClass allInstVarNames reject: [:iv | aClass instVarNames includes: iv]) asSortedCollection do: [:vname|
		pal addElement: (ObjectElementMorph new label: vname asString) ].

	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:24'!
labelColor
	^Color darkGray twiceDarker! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:32'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 9! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:51'!
messagesFor: aClass
	
	| pal me |
	pal _ self new.
	pal addElement: ((StringMorph contents: (SyntaxElementMorph wordsFrom: aClass name asString) font: self labelFont) color: self labelColor).
	aClass selectors asSortedCollection do: [:selector|
		me _ MessageElementMorph new selector: selector.
		((selector asString includes: ($:)) not and: [
			(aClass lookupSelector: selector) numArgs > 0])
				ifTrue: [me beBinary].
		pal addElement: me ].

	pal addElement: ((StringMorph contents: ' inherited:' font: self labelFont) color: self labelColor).

	(aClass allSelectors reject:[:sel| aClass selectors includes: sel ]) asSortedCollection do: [:selector|
		me _ MessageElementMorph new selector: selector.
		((selector asString includes: ($:)) not and: [
			(aClass lookupSelector: selector) numArgs > 0])
				ifTrue: [me beBinary].
		pal addElement: me ].


	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 00:16'!
messagesForSelf: aClass
	
	| pal me|
	pal _ self new.
	aClass allSelectors asSortedCollection do: [:selector|
		me _ MessageElementMorph new selector: selector.
		((selector asString includes: ($:)) not and: [
			(aClass lookupSelector: selector) numArgs > 0])
				ifTrue: [me beBinary].
		me receiver: (ObjectElementMorph new label: 'self').
		pal addElement: me ].
	^pal
! !

!ElementPaletteMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:10'!
packageClassesDict
	| packages pkg ans |
	packages _ Dictionary new.
	ans _ Dictionary new.
	SystemOrganization categories asSortedCollection do: [:cat |
		pkg _ (cat asString findTokens: #( $- )) first.
		(packages includesKey: pkg) ifFalse: [
				packages at: pkg put: OrderedCollection new.
				ans at: pkg put: OrderedCollection new].
		(packages at: pkg) add: cat].

	packages keys do: [:eachPkg |
		(packages at: eachPkg) do: [: cat |
			(ans at: eachPkg) addAll:  (SystemOrganization listAtCategoryNamed: cat) ]].
	^ans! !


Morph subclass: #ElementsButtonMorph
	instanceVariableNames: 'target selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:07'!
borderColorDark
	^color twiceDarker! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:07'!
borderColorLight
	^color twiceLighter lighter! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:07'!
borderColorVeryDark
	^color twiceDarker darker! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:07'!
borderColorVeryLight
	^color twiceLighter twiceLighter lighter! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:06'!
borderWidth
	^1
! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 20:55'!
handlesMouseDown: evt
	^ true
! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:46'!
labelColor
	^Color white! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:46'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 12! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 20:59'!
mouseDown: evt
	target perform: selector! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 20:58'!
selector: aSelector
	selector _ aSelector! !

!ElementsButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 20:58'!
target: anObject
	target _ anObject! !


Morph subclass: #ElementsMethodEditorMorph
	instanceVariableNames: 'classChooser methodChooser sideChooser palette editor saver methodModified fillScreenOn currentMethod currentClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:28'!
about
	self inform: '- Elements -

a graphical Smalltalk
------------------------------
experimental release of Aug. 24 2009
 
written by Jens Mnig (jens@moenig.org)
all rights reserved
 
inspired by Scratch from the MIT Media Lab
and based in part on the Scratch Source Code.
Implemented in Squeak and in itself.'! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 23:05'!
arrangeElements
	| current x y spacing |
	spacing _ 5.
	current _ self currentMethodElement.
	x _ editor contents left + spacing.
	y _ current stackBottom + spacing.
	editor contents submorphsDo: [:element |
		(element == current) ifFalse:[
			element position: x @ y.
			y _ element bottom + spacing ]]
		! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 15:47'!
arrangePanes
	classChooser position: self topLeft + 2.
	sideChooser position: classChooser bottomLeft.
	methodChooser position: sideChooser bottomLeft.
	editor position: (self left + 4) @ (methodChooser bottom + 4);
		extent: (self width - 180 - 8) @ (self bottom - editor top - 4).
	palette position: editor right @ (classChooser bottom);
		height: self bottom - palette top - 4;
		arrangePanes.
	saver position: (self position x + (palette left - methodChooser right - saver width // 2) ) @ (methodChooser bottom - saver height)
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 22:36'!
buildPanes
	| p m |
	classChooser _ ClassChooserMorph new frame: self; class: Object.
	sideChooser _ InstanceClassSwitchMorph new frame: self.
	methodChooser _ MethodChooserMorph new frame: self; class: Object; selector: #yourself.
	editor _ ElementsScrollFrameMorph new
				color: Color gray;
				borderColor: Color gray.
	p _ PasteUpMorph new borderWidth: 0; color: Color gray darker.
	m _ MethodElementMorph new selector: '' arguments: #().
	editor contents: p.
	p addMorph: m.

	palette _ ElementsPaletteFrameMorph new editorFrame: self; height: self height; arrangePanes.
	saver _ ElementsToggleButtonMorph new flat; label: 'save'; onColor: color offColor: color; target: self; selector: #saveCurrentMethod.
	self
		addMorph: classChooser;
		addMorph: sideChooser;
		addMorph: methodChooser;
		addMorph: editor;
		addMorph: palette;
		addMorph: saver.
	saver isHidden: true! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:29'!
contextMenu
	|m|
	m _ CustomMenu new.
	m add: 'clean up' action: #arrangeElements.
"
	m addLine.
	fillScreenOn
		ifTrue: [
			m add: 'switch to development mode' action: #developmentMode.
]
		ifFalse: [m add: 'switch to user mode' action: #userMode.
			m add: 'save image in user mode' action: #saveImage ].
"
	m addLine.
	m add: 'about...' action: #about.

	^m! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:21'!
currentClass
	^currentClass! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:24'!
currentMethodElement
	^editor contents findA: MethodElementMorph
	! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:01'!
currentSide
	sideChooser ifNil: [^#instance ].
	^sideChooser choice! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:35'!
developmentMode
	fillScreenOn _ false.
	self
		position: World topLeft;
		extent: World extent - 50;
		arrangePanes.
	palette arrangePanes.	
	Preferences disable: #noviceMode.
	Preferences enable: #warnIfNoSourcesFile.
	Preferences enable: #warnIfNoChangesFile.

! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:28'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:44'!
initialize
	fillScreenOn _ false.
	methodModified _ false.
	currentClass _ Object.
	currentMethod _ #yourself.
	super initialize.
	self extent: 600 @ 400.
	color _ Color gray.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:29'!
invokeContextMenu
	|m choice|
	m _ self contextMenu.
	m ifNotNil: [
		choice _ m startUp.
		choice ifNotNil: [self perform: choice] ]! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 13:22'!
maximize
	((self position = World position) and: [
		self extent = World extent])
		ifTrue: [^self].
	self
		position: World topLeft;
		extent: World extent;
		arrangePanes.
	palette arrangePanes.
	self comeToFront
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 15:48'!
methodModified
	methodModified _ true.
	saver isHidden: false.
	saver position: (self position x + (palette left - methodChooser right - saver width // 2) ) @ (methodChooser bottom - saver height)! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 22:47'!
methodTemplate
	| m |
	m _ MethodElementMorph new selector: '' arguments: #().
	self currentMethodElement delete.
	m position: editor contents position.
	editor contents addMorph: m fitMethod.
	self isInWorld ifFalse: [^self].
	methodChooser selector: nil.
	self methodUnmodified! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:32'!
methodUnmodified
	methodModified _ false.
	saver isHidden: true! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 10:46'!
mouseDown: evt
	"Handle a mouse down event."

	evt rightButtonPressed
		ifTrue: [ ^self invokeContextMenu].
	Preferences noviceMode ifTrue: [^self].
	self startDrag: evt
! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:59'!
onMethod: aSelector ofClass: aClass
	methodModified _ false.
	currentClass _ aClass.
	classChooser class: aClass.
	currentMethod _ #aSelector.
	methodChooser selector: aSelector.
	methodChooser class: aClass.
	palette class: aClass.
"	self refresh"! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 01:09'!
refresh
	self methodTemplate! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:58'!
saveCurrentMethod
	| se sel|
	se _ self currentMethodElement.
	sel _ se selector.

	currentClass compile: se asSmalltalk
					classified: ClassOrganizer nullCategory
					notifying: nil.

	methodChooser selector: sel.
	self selectMethod: sel.
	palette refresh! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 01:07'!
saveImage

	self userMode.
	self maximize.
	World allMorphsDo: [:m|
		(m isKindOf: SystemWindow)
			ifTrue: [m delete ]].
	World activeHand saveAndQuit! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 20:50'!
selectClass: aClass
	editor ifNil: [^self].
	(currentClass = aClass)
		ifTrue: [^self].

	currentClass _ aClass.
	classChooser class: currentClass.
	methodChooser class: currentClass.
	palette class: currentClass.
	self methodTemplate
	! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 21:28'!
selectMethod: aSelector
	| myMethod temps se |

	currentMethod _ aSelector.
	editor ifNil: [^self].
	currentMethod ifNil: [^self].
	currentClass ifNotNil:
		[myMethod _ currentClass compiledMethodAt: currentMethod ifAbsent: [^self methodTemplate].
		temps _ (currentClass compilerClass new
						parse: myMethod getSourceFromFile asString in: currentClass notifying: nil)
						tempNames.

	se _ ((currentClass decompilerClass new withTempNames: temps)
		decompile: currentMethod in: currentClass method: myMethod) asSyntaxElement.

	self currentMethodElement delete.
	se position: editor contents position.
	editor contents addMorph: se fitMethod.

	^self methodUnmodified.
		].

	^self methodTemplate

! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:38'!
step
	fillScreenOn 
		ifTrue: [self maximize]
		ifFalse: [^self arrangePanes].! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 20:10'!
stepTime
	^0! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 11:17'!
switchToClassSide

	self selectClass: currentClass class! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 11:17'!
switchToInstanceSide

	self selectClass: currentClass allInstances first.! !

!ElementsMethodEditorMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 17:33'!
userMode

	fillScreenOn _ true.
	Preferences enable: #noviceMode.
	Preferences disable: #warnIfNoSourcesFile.
	Preferences disable: #warnIfNoChangesFile.

! !


Morph subclass: #ElementsPaletteFrameMorph
	instanceVariableNames: 'header palette editorFrame currentClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:30'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."

	aMorph delete
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:14'!
arrangePanes
	header position: self position;
		width: self width;
		arrangePanes.
	palette position: self left @ header bottom;
		extent: self width @ (self height - header height)! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 01:25'!
buildPanes
	header _ PaletteFrameHeadMorph new frame: self.
	palette _ ElementsScrollFrameMorph new
				color: Color gray;
				borderColor: Color gray.
	self
		addMorph: header;
		addMorph: palette.! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 22:06'!
class: aClass
	currentClass _ aClass.
	header adjustToClass: currentClass.
	self refresh! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:17'!
classMenu
	|menu|
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'create a subclass...' action: #createSubclass.
	menu add: 'remove a class...' action: #removeClass.
	^menu! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:40'!
classVarMenu
	|menu|
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'add a class variable...' action: #createClassVar.
	menu add: 'remove a variable...' action: #removeClassVar.
	^menu! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2009 02:41'!
contextMenu
	| choice |
	choice _ header choice.
	(#basics = choice) ifTrue: [^nil ].

	(#(allClasses #currentPackageClasses) includes: choice) ifTrue: [
		^self classMenu].

	(#variables = choice) ifTrue: [
		(currentClass isMeta)
			ifTrue: [ ^self classVarMenu]
			ifFalse: [ ^self instanceVarMenu ]].

	(#instanceVars = choice) ifTrue: [^self instanceVarMenu].

	(#classVars = choice) ifTrue: [^self classVarMenu].

	(#globalVars = choice) ifTrue: [ ^self globalVarMenu].

	(#currentMessages = choice) ifTrue: [^self methodMenu].

	(#methodsClass = choice) ifTrue: [^nil ].! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:41'!
createClassVar
	|varName current|
	currentClass isMeta
		ifTrue: [current _ currentClass theNonMetaClass ]
		ifFalse: [current _ currentClass ].

	varName _ FillInTheBlank request: 'variable name:' initialAnswer: ''.
	varName isEmpty ifTrue: [^self].
	current addClassVarName: varName.
	self refresh		! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:07'!
createGlobalVar
	|varName |

	varName _ FillInTheBlank request: 'variable name:' initialAnswer: ''.
	varName isEmpty ifTrue: [^self].
	varName _ SyntaxElementMorph classNameFrom: varName.
	(Smalltalk includesKey: varName asSymbol)
		ifTrue: [^self inform: varName, ' is already in use'].
	Smalltalk at: varName asSymbol put: nil.
	self refresh		! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:08'!
createInstVar
	|varName current|
	currentClass isMeta
		ifTrue: [current _ currentClass theNonMetaClass ]
		ifFalse: [current _ currentClass ].

	varName _ FillInTheBlank request: 'variable name:' initialAnswer: ''.
	varName isEmpty ifTrue: [^self].
	varName _ SyntaxElementMorph objectNameFrom: varName.
	current addInstVarName: varName.
	self refresh		! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:09'!
createSubclass
	|className categoryName current newClass|
	currentClass isMeta
		ifTrue: [current _ currentClass theNonMetaClass ]
		ifFalse: [current _ currentClass ].

	className _ FillInTheBlank request: 'class name:' initialAnswer: ''.
	className isEmpty ifTrue: [^self].
	categoryName _ FillInTheBlank request: 'category:' initialAnswer: 'UserObjects'.
	categoryName isEmpty ifTrue: [^self].

	className _ SyntaxElementMorph classNameFrom: className.

	newClass _ current subclass: className asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: categoryName.

	editorFrame selectClass: newClass

		! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:12'!
currentClass
	^currentClass! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 12:48'!
currentMethodsClass
	
	| name |
	name _ palette contents submorphs last contents.
	(name endsWith: ' class') ifTrue: [
		name _ (name reversed copyFrom: 6 to: name size) reversed.
		name _ name reject: [:c| c = $ ].
		^(Smalltalk at: name asSymbol) class ].

	name _ name reject: [:c| c = $ ].
	^Smalltalk at: name asSymbol! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 13:42'!
editorFrame: aMorph
	editorFrame _ aMorph! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:56'!
globalVarMenu
	|menu|
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'add a global variable...' action: #createGlobalVar.
	menu add: 'remove a variable...' action: #removeGlobalVar.
	^menu! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 19:50'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 20:42'!
initialize
	super initialize.
	currentClass _ Object.
	self extent: 180 @ 400.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:26'!
instanceVarMenu
	|menu|
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'add an instance variable...' action: #createInstVar.
	menu add: 'remove a variable...' action: #removeInstVar.
	^menu! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 20:45'!
invokeContextMenu
	|m |
	m _ self contextMenu.
	m ifNotNil: [m popUpNearHand]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:13'!
methodMenu
	|menu|
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'remove a method...' action: #removeMethod.
	^menu! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 19:51'!
mouseDown: evt
	"Handle a mouse down event."

	evt rightButtonPressed
		ifTrue: [ ^self invokeContextMenu].
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:02'!
refresh
	| choice |
	choice _ header choice.
	(#basics = choice) ifTrue: [
		palette contents: ElementPaletteMorph basics ].

	(#allClasses = choice) ifTrue: [
		palette contents: ElementPaletteMorph classes ].

	(#currentPackageClasses = choice) ifTrue: [
		(currentClass isKindOf: Metaclass)
			ifTrue: [ palette contents: (ElementPaletteMorph currentPackageClasses: currentClass allInstances first) ]
			ifFalse: [palette contents: (ElementPaletteMorph currentPackageClasses: currentClass) ]].


	(#variables = choice) ifTrue: [
		(currentClass isKindOf: Metaclass)
			ifTrue: [ palette contents: (ElementPaletteMorph classVarsFor: currentClass allInstances first) ]
			ifFalse: [palette contents: (ElementPaletteMorph instVarsFor: currentClass) ]].

	(#instanceVars = choice) ifTrue: [
		(currentClass isKindOf: Metaclass)
			ifTrue: [palette contents: (ElementPaletteMorph instVarsFor: currentClass allInstances first) ]
			ifFalse: [palette contents: (ElementPaletteMorph instVarsFor: currentClass) ]].

	(#classVars = choice) ifTrue: [
		(currentClass isKindOf: Metaclass)
			ifTrue: [palette contents: (ElementPaletteMorph classVarsFor: currentClass allInstances first) ]
			ifFalse: [palette contents: (ElementPaletteMorph classVarsFor: currentClass) ]].

	(#globalVars = choice) ifTrue: [
		palette contents: (ElementPaletteMorph globals) ].



	(#currentMessages = choice) ifTrue: [
		palette contents: (ElementPaletteMorph messagesFor: currentClass) ].

	(#methodsClass = choice) ifTrue: [
		palette contents: (ElementPaletteMorph messagesFor: header methodsClass) ].! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:21'!
removeClass
	| class |
	class _ self selectClass.
	class ifNotNil: [
		class _ Smalltalk at: class.
		self removeClass: class ]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:22'!
removeClass: aClass

		(editorFrame currentClass = aClass)
			ifTrue: [editorFrame selectClass: Object ].
		aClass removeFromSystem.
		self refresh ! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:43'!
removeClassVar
	| var |
	var _ self selectClassVar.
	var ifNotNil: [
		self currentClass removeClassVarName: var.
		self refresh ]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:02'!
removeGlobalVar
	| var |
	var _ self selectGlobalVar.
	var ifNotNil: [
		Smalltalk removeKey: var.
		self refresh ]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:35'!
removeInstVar
	| var |
	var _ self selectInstVar.
	var ifNotNil: [
		self currentClass removeInstVarName: var.
		self refresh ]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:15'!
removeMethod
	| sel |
	sel _ self selectSelector.
	sel ifNotNil: [
		self currentClass removeSelector: sel.
		self refresh ]! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:07'!
selectClass
	^(CustomMenu selections: Smalltalk classNames) startUp
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:44'!
selectClassVar
	^(CustomMenu selections: currentClass classVarNames asSortedCollection) startUp
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:03'!
selectGlobalVar
	^(CustomMenu selections: (Smalltalk keys reject: [:key| Smalltalk classNames includes: key]) asSortedCollection) startUp
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 21:34'!
selectInstVar
	^(CustomMenu selections: currentClass instVarNames) startUp
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:16'!
selectSelector
	^(CustomMenu selections: currentClass selectors asSortedCollection) startUp
! !

!ElementsPaletteFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:29'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. The default implementation returns false.
NOTE: the event is assumed to be in global (world) coordinates."

	^aMorph isKindOf: SyntaxElementMorph! !


BorderedMorph subclass: #ElementsScrollFrameMorph
	instanceVariableNames: 'contents hScrollbar vScrollbar cornerMorph hbarInset vbarInset contentsChanged growthFraction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!
!ElementsScrollFrameMorph commentStamp: '<historical>' prior: 0!
I have largely been copied from the Scratch-UI which was originally written by John Maloney and Evelyn Eastmond!


!ElementsScrollFrameMorph methodsFor: 'initialization' stamp: 'jens 2/4/2009 20:53'!
initialize

	super initialize.
	self color: Color red.
	hbarInset _ 12.
	vbarInset _ 12.
	contentsChanged _ false.
	growthFraction _ 0.6.  "amount to grow when contents do not fit as a fraction of the current size"

	contents _ PasteUpMorph new
		color: Color red;
		borderWidth: 0;
		enableDragNDrop: true.

	hScrollbar _ ScrollBar new
		model: self;
		setValueSelector: #hScrollRelative:;
		hasMenuButton: false.
	vScrollbar _ ScrollBar new
		model: self;
		setValueSelector: #vScrollRelative:;
		hasMenuButton: false.

	cornerMorph _ BorderedMorph new
		borderRaised; borderWidth: 1; color: hScrollbar color.

	contents position: self position + borderWidth.
	self addMorph: contents.
	self addMorph: hScrollbar.
	self addMorph: vScrollbar.
	self addMorph: cornerMorph.
	self extent: 160@120.
! !


!ElementsScrollFrameMorph methodsFor: 'accessing' stamp: 'jens 2/4/2009 20:28'!
contents
	"Answer my contents morph."

	^ contents
! !

!ElementsScrollFrameMorph methodsFor: 'accessing' stamp: 'jens 2/4/2009 20:28'!
contents: aMorph
	"Replace my contents morph. The argument can be any morph. Typically it is a BorderedMorph or a PasteUpMorph."

	contents ifNotNil: [contents delete].
	contents _ aMorph.
	contents position: self topLeft + borderWidth.
	self addMorphBack: contents.
	self extent: self extent.
! !

!ElementsScrollFrameMorph methodsFor: 'accessing' stamp: 'jens 2/4/2009 20:28'!
growthFraction: aNumber
	"Set the amount to grow when contents do not fit, expressed as a fraction of the current size. For example, 0.5 makes the contains pane 50% larger if any submorph extends over the edge."

	growthFraction _ aNumber max: 0.0.
! !

!ElementsScrollFrameMorph methodsFor: 'accessing' stamp: 'jens 2/4/2009 20:28'!
hBarInset: anInteger

	hbarInset _ anInteger.
! !

!ElementsScrollFrameMorph methodsFor: 'accessing' stamp: 'jens 2/4/2009 20:28'!
vBarInset: anInteger

	vbarInset _ anInteger.
! !


!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
hScrollPixels
	"Answer the current horizontal scroll offset in pixels."

	^ (self left + borderWidth) - contents left

! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
hScrollPixels: hOffset
	"Scroll to the given horizontal offset in pixels. Zero is scrolled to the left and increasing values scroll right."

	| delta maxOffset |
	delta _ (hOffset asInteger min: self maxScroll x) max: 0.
	contents left: ((self left + borderWidth) - delta) truncated.

	maxOffset _ self maxScroll x.
	maxOffset > 0 ifTrue: [hScrollbar value: self hScrollPixels / maxOffset].
! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
hScrollRelative: aFloat
	"Sent by the horizontal scrollbar. Scroll to the given relative postion between 0.0 and 1.0."

	self hScrollPixels: aFloat * self maxScroll x.
! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
maxScroll
	"Answer a point representing the maximum horizontal and vertical scroll offsets in pixels."

	^ contents extent - self visibleExtent
! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
scrollSubmorphIntoView: aMorph

	| offset |
	(contents submorphs includes: aMorph) ifFalse: [^ self].
	(self bounds containsRect: aMorph fullBounds) ifTrue: [^ self].

	(aMorph fullBounds bottom > self bottom) ifTrue: [
		offset _ aMorph fullBounds bottom - contents top.
		contents top: (self bottom - 3) - offset].

	(aMorph fullBounds top < self top) ifTrue: [
		offset _ aMorph fullBounds top - contents top.
		contents top: (self top + 3) - offset].

	self updateScrollbars.
! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
vScrollPixels
	"Answer the current vertical scroll offset in pixels."

	^ (self top + borderWidth) - contents top

! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
vScrollPixels: vOffset
	"Scroll to the given vertical offset in pixels. Zero is scrolled to the top and increasing values scroll down."

	| delta maxOffset |
	delta _ (vOffset asInteger min: self maxScroll y) max: 0.
	contents top: ((self top + borderWidth) - delta) truncated.

	maxOffset _ self maxScroll y.
	maxOffset > 0 ifTrue: [vScrollbar value: self vScrollPixels / maxOffset].
! !

!ElementsScrollFrameMorph methodsFor: 'scrolling' stamp: 'jens 2/4/2009 20:28'!
vScrollRelative: aFloat
	"Sent by the vertical scrollbar. Scroll to the given relative postion between 0.0 and 1.0."

	self vScrollPixels: aFloat * self maxScroll y.
! !


!ElementsScrollFrameMorph methodsFor: 'scrollbar visibility' stamp: 'jens 2/4/2009 20:28'!
showHorizontalScrollbar: aBoolean
	"Show or hide my horizontal scrollbar."

	aBoolean
		ifTrue: [
			self addMorph: hScrollbar.
			vScrollbar owner = self ifTrue: [self addMorph: cornerMorph]]
		ifFalse: [
			hScrollbar delete.
			cornerMorph delete].

	super extent: self extent.
! !

!ElementsScrollFrameMorph methodsFor: 'scrollbar visibility' stamp: 'jens 2/4/2009 20:28'!
showVerticalScrollbar: aBoolean
	"Show or hide my vertical scrollbar."

	aBoolean
		ifTrue: [
			self addMorph: vScrollbar.
			hScrollbar owner = self ifTrue: [self addMorph: cornerMorph]]
		ifFalse: [
			vScrollbar delete.
			cornerMorph delete].

	super extent: self extent.
! !


!ElementsScrollFrameMorph methodsFor: 'drawing' stamp: 'jens 2/4/2009 20:28'!
drawSubmorphsOn: aCanvas
	"If my contents has changed, fix it's extent and update my scrollbar ranges. Clip submorph drawing to my bounds."

	contentsChanged ifTrue: [
		self updateContentsExtent.
		self updateScrollbars.
		contentsChanged _ false].

	super drawSubmorphsOn: (aCanvas copyClipRect: self innerBounds).
! !


!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
hResizing

	^ #spaceFill
! !

!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
isAlignmentMorph
	"Answer true, since I can be laid out as if I were an AlignmentMorph. I pretend to be an AlignmentMorph so that I can be resized when I'm inside another AlignmentMorph."

	^ true
! !

!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
layoutInWidth: w height: h
	"Resize myself to the given width and height. Called during when I am in an AlignmentMorph."

	self extent: w@h.
! !

!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
minHeight

	^ 45
! !

!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
minWidth

	^ 60
! !

!ElementsScrollFrameMorph methodsFor: 'layout' stamp: 'jens 2/4/2009 20:28'!
vResizing

	^ #spaceFill
! !


!ElementsScrollFrameMorph methodsFor: 'geometry' stamp: 'jens 2/4/2009 20:28'!
extent: aPoint
	"After setting my size, position and size my scrollbars and grow box. Also update my contents and scrollbar ranges."

	| inner w h |
	super extent: (aPoint truncated max: self minWidth@self minHeight).
	inner _ self innerBounds.

	w _ inner width.
	vScrollbar owner = self ifTrue: [w _ w - vbarInset].
	hScrollbar position: inner left@(inner bottom - hbarInset).
	hScrollbar extent: w@hbarInset.

	h _ inner height.
	hScrollbar owner = self ifTrue: [h _ h - hbarInset].
	vScrollbar position: (inner right - vbarInset)@inner top.
	vScrollbar extent: vbarInset@h.

	cornerMorph position: (inner bottomRight - (vbarInset@hbarInset)).
	cornerMorph extent: vbarInset@hbarInset.

	self updateContentsExtent.
	self updateScrollbars.
! !

!ElementsScrollFrameMorph methodsFor: 'geometry' stamp: 'jens 2/4/2009 20:28'!
fullBounds
	"Overridden to clip submorph hit detection to my bounds."

	^ bounds
! !

!ElementsScrollFrameMorph methodsFor: 'geometry' stamp: 'jens 2/4/2009 20:28'!
invalidRect: damageRect
	"Clip damage reports to my bounds, since drawing is clipped to my bounds."

	| r |
	r _ damageRect intersect: self bounds.
	(r width > 0 and: [r height > 0]) ifTrue: [super invalidRect: r].
! !

!ElementsScrollFrameMorph methodsFor: 'geometry' stamp: 'jens 2/4/2009 20:28'!
layoutChanged
	"If my contents morph's layout has changed, record that fact."

	super layoutChanged.
	contents mayNeedLayout ifTrue: [contentsChanged _ true].
! !


!ElementsScrollFrameMorph methodsFor: 'private' stamp: 'jens 2/4/2009 20:28'!
contentsBounds
	"Answer a rectangle that encloses the bounds of all my submorphs."

	| offset r |
	offset _ contents topLeft negated.
	r _ 0@0 extent: 1@1.
	contents submorphsDo: [:m |
		r _ r quickMerge: (m fullBounds translateBy: offset) truncated].
	^ r
! !

!ElementsScrollFrameMorph methodsFor: 'private' stamp: 'jens 2/5/2009 01:28'!
updateContentsExtent
	"Make sure my content morph is large enough to both enclose all it's submorphs and to fill me. Adjust the scroll offsets if my bounds have shrunk."

	| r delta scrolledOff w h visible |
	r _ self contentsBounds.
	((r left < 0) or: [r top < 0]) ifTrue: [
		"contents has morphs that stick out over its top or left edge"
		delta _ (r topLeft truncated min: (0@0)) negated.
		contents submorphsDo: [:m | m position: m position + delta]].  "move all submorphs by delta"

	visible _ self visibleExtent - (8@20).
	w _ visible x. r width > w ifTrue: [w _ (r width + (growthFraction * visible x)) rounded].
	h _ visible y. r height > h ifTrue: [h _ (r height + (growthFraction * visible y))  rounded].

	scrolledOff _ ((self topLeft + borderWidth) - contents position) max: 0@0.
	contents extent: ((w@h) max: (self visibleExtent + scrolledOff)).
	contentsChanged _ false.
! !

!ElementsScrollFrameMorph methodsFor: 'private' stamp: 'jens 2/4/2009 20:28'!
updateScrollbars
	"Update my scrollbars based on my current contents."

	| visibleExtent currentScroll maxScroll |
	contents ifNil: [^ self].  "not fully initialized yet"
	visibleExtent _ self visibleExtent.
	hScrollbar percentVisible: (visibleExtent x asFloat / contents width).
	vScrollbar percentVisible: (visibleExtent y asFloat / contents height).

	currentScroll _ (self topLeft + borderWidth) - contents position.
	contents width > visibleExtent x
		ifTrue: [
			maxScroll _ contents width - visibleExtent x.
			self showHorizontalScrollbar: true.
			hScrollbar
				scrollDelta: 4 / maxScroll asFloat 
				pageDelta: (visibleExtent x - 40) / maxScroll asFloat.
			hScrollbar value: currentScroll x / maxScroll]
		ifFalse: [
			self showHorizontalScrollbar: false.
			hScrollbar value: 0].

	contents height > visibleExtent y
		ifTrue: [
			maxScroll _ contents height - visibleExtent y.
			self showVerticalScrollbar: true.
			vScrollbar
				scrollDelta: 4.0 / maxScroll asFloat 
				pageDelta: (visibleExtent y - 40) / maxScroll asFloat.
			vScrollbar value: currentScroll y / maxScroll]
		ifFalse: [
			self showVerticalScrollbar: false.
			vScrollbar value: 0].
! !

!ElementsScrollFrameMorph methodsFor: 'private' stamp: 'jens 2/4/2009 20:28'!
visibleExtent
	"Answer the extent of my visible area. That is, the area within my borders minus the space used for scrollbars."

	| clipToScrollBarEdge visibleW visibleH |
	clipToScrollBarEdge _ false.
	clipToScrollBarEdge ifFalse: [^ self extent - (2 * borderWidth)].

	visibleW _ self width - (2 * borderWidth).
	vScrollbar owner = self ifTrue: [visibleW _ visibleW - vbarInset].
	visibleH _ self height - (2 * borderWidth).
	hScrollbar owner = self ifTrue: [visibleH _ visibleH - hbarInset].
	^ visibleW@visibleH
! !


ElementsButtonMorph subclass: #ElementsToggleButtonMorph
	instanceVariableNames: 'onColor offColor label on specialEffect '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:50'!
drawOn: aCanvas 

	|r bw |
	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color.
"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self bottomRight - bw)) color: color.

"

specialEffect ifTrue: [

	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self left + self height) @ (self center y - bw)) color: onColor twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self left + self height) @ (self center y)) color: onColor lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self left + self height) @ (self bottom - bw)) color: onColor


]! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:42'!
fitMorphs
	| bw x y |
	bw _ self borderWidth.
	self height: label height + (bw * 2).
	x _ self left + ((self width - label width) // 2).
	y _ self top + bw.
	label position: x@ y ! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:49'!
flat
	specialEffect _ false! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:49'!
initialize
	super initialize.
	specialEffect _ true.
	on _ true.
	target _ self.
	selector _ #toggle.
	onColor _ Color blue.
	offColor _ Color gray.
	self label: 'Elements Toggle Button'.
	self toggle! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
isOn
	^on! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:03'!
label: aString

	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	label contents: aString.
	self fitMorphs
! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:47'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 10! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
off
	on _ false.
	self color: offColor! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
on
	on _ true.
	self color: onColor! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 01:24'!
onColor: onc offColor: offc
	onColor _ onc.
	offColor _ offc! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:07'!
toggle
	self fitMorphs.
	on ifTrue: [^self off].
	self on! !


ElementsToggleButtonMorph subclass: #ElementsDoubleToggleMorph
	instanceVariableNames: 'chooser '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:28'!
chooser: aSelector
	chooser selector: aSelector! !

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:38'!
fitMorphs
	| bw x y |
	chooser ifNil: [^super fitMorphs].
	bw _ self borderWidth.
	self height: label height + (bw * 2).
	y _ self top + bw.

	chooser extent: (label height @ label height) * 2//3.
	chooser position: self left + bw @ self top + (label height - chooser height // 2).

	x _ chooser right + bw + (self width - label width // 2).

	label position: x@ y.
! !

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:43'!
initialize
	super initialize.
	chooser _ TriangleButtonMorph new
				target: self;
				selector: #test.
	self addMorph: chooser.
	self fitMorphs! !

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:30'!
selector: anObject
	super selector: anObject.
	chooser selector: anObject! !

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:30'!
target: anObject
	super target: anObject.
	chooser target: anObject! !

!ElementsDoubleToggleMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:31'!
test
	self inform: 'Hi'! !


Morph subclass: #InstanceClassSwitchMorph
	instanceVariableNames: 'instance class choice frame '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:11'!
arrangePanes

	| toggleWidth |
	toggleWidth _ self width - 6 // 2.

	instance 
		width: toggleWidth;
		position: self topLeft + 2;
		fitMorphs.

	class 
		width: toggleWidth;
		position: instance right + 2 @ (instance top);
		fitMorphs.

	self height: class bottom + 2 - self top! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:17'!
buildPanes

	instance _ ElementsToggleButtonMorph new
				target: self;
				selector: #instance;
				label: 'instance';
				onColor: Color blue darker offColor: color.

	class _ ElementsToggleButtonMorph new
				target: self;
				selector: #class;
				label: 'class';
				onColor: Color magenta twiceDarker offColor: color.

	self
		addMorph: instance;
		addMorph: class
! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:12'!
choice
	^choice! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:28'!
class
	(choice = #class) ifTrue: [^self].
	choice _ #class.
	frame ifNotNil: [
		frame switchToClassSide.
		self refresh ]! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:19'!
frame: aMorph
	frame _ aMorph! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:07'!
initialize
	super initialize.
	choice _ #instance.
	color _ Color gray.
	self width: 180.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:29'!
instance
	(choice = #instance) ifTrue: [^self].
	choice _ #instance.
	frame ifNotNil: [
		frame switchToInstanceSide.
		self refresh ]! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:13'!
refresh

	instance off.
	class off.

	(#instance = choice) ifTrue: [
		instance on ].
	(#class = choice) ifTrue: [
		class on ].

! !


ClassChooserMorph subclass: #MethodChooserMorph
	instanceVariableNames: 'selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:05'!
addCategory
	| ans |
	ans _ FillInTheBlank request: 'new category:' initialAnswer: ''.
	(ans size > 0) ifFalse: [^self].
	class organization addCategory: ans! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:11'!
chooseMethod

	|menu list|
	menu _ MenuMorph new.
	menu defaultTarget: self.
	selector ifNotNil: [
		menu add: 'put method into category...' action: #reclassify.
		menu add: 'add category...' action: #addCategory.
		menu add: 'remove empty categories' action: #removeEmptyCategories.
		menu addLine ].
	list _ class organization categories asSortedCollection.
	list do: [:each|
		menu add: each asString subMenu: (self menuForCategory: each)].
	menu popUpAt: button center x @ (self bottom + 5) forHand: World activeHand! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:14'!
class: aClass
	class _ aClass. ! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:44'!
initialize
	super initialize.
	class _ Object.
	selector _ #yourself.
	button selector: #chooseMethod
	! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 01:17'!
menuForCategory: categoryName

	|menu list |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ class organization listAtCategoryNamed: categoryName.
	list isEmpty ifTrue: [
		menu add: 'yourself' selector: #selector: argument: #yourself.
		^menu ].
	list asSortedCollection do: [:each|
		menu add: (self wordsFrom: each asString) selector: #selector: argument: each].
	^menu
! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:35'!
mouseDown: evt
	self chooseMethod! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 12:57'!
reclassify
	class organization letUserReclassify: selector! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:09'!
removeEmptyCategories

	class organization removeEmptyCategories! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:23'!
selector
	^selector! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 22:17'!
selector: aSelector

	selector _ aSelector.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	aSelector isNil
		ifTrue: [ label contents: '' ]
		ifFalse: [ label contents: (self wordsFrom: selector asString)].
	self fitMorphs.

	frame ifNotNil: [frame selectMethod: aSelector]
! !


Morph subclass: #PaletteFrameHeadMorph
	instanceVariableNames: 'classChooser basics variables classes messages choice lastMsgChoice frame methodsClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 22:10'!
adjustToClass: aClass
	(aClass isKindOf: Metaclass)
		ifTrue: [
			(#instanceVars = choice)
				ifTrue: [choice _ #variables]]! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:25'!
allClasses
	choice _ #allClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 20:29'!
arrangePanes

	| toggleWidth |
	toggleWidth _ self width - 6 // 2.

	basics 
		width: toggleWidth;
		position: self topLeft + 2;
		fitMorphs.

	messages 
		width: toggleWidth;
		position: basics left @ (basics bottom + 2);
		fitMorphs.

	variables 
		width: toggleWidth;
		position: (basics right + 2) @ (basics top);
		fitMorphs.

	classes 
		width: toggleWidth;
		position: (basics right + 2) @ (variables bottom + 2);
		fitMorphs.

	self height: messages bottom + 2 - self top! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:16'!
basics
	choice _ #basics.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:44'!
buildPanes

	basics _ ElementsToggleButtonMorph new
				target: self;
				selector: #basics;
				label: 'Basics';
				onColor: Color green twiceDarker darker offColor: color.

	variables _ ElementsDoubleToggleMorph new
				target: self;
				selector: #variables;
				chooser: #varMenu;
				label: 'Variables';
				onColor: Color blue darker offColor: color.

	classes _ ElementsDoubleToggleMorph new
				target: self;
				selector: #classes;
				chooser: #classMenu;
				label: 'Classes';
				onColor: Color magenta darker darker darker offColor: color.

	messages _ ElementsDoubleToggleMorph new
				target: self;
				selector: #messages;
				chooser: #chooseClassForMethods;
				label: 'Messages';
				onColor: Color orange darker darker offColor: color.

	self
		addMorph: basics;
		addMorph: variables;
		addMorph: classes;
		addMorph: messages
! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:24'!
choice
	^choice! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 12:49'!
chooseClassForMethods

	| menu packages pkg pkgMenu catMenu superc subc smenu currentClass |

	self messages.	

	packages _ Dictionary new.
	SystemOrganization categories asSortedCollection do: [:cat |
		pkg _ (cat asString findTokens: #( $- )) first.
		(packages includesKey: pkg)
			ifFalse: [ packages at: pkg put: OrderedCollection new].
		(packages at: pkg) add: cat].

	currentClass _ self currentMethodsClass.

	superc _ currentClass allSuperclasses.
	subc _ currentClass allSubclasses.

	menu _ MenuMorph new.

	menu defaultTarget: self.
	menu add: 'current class' action: #currentMessages.

	currentClass isMeta
		ifTrue: [ menu add: 'instance side' selector: #setMethodsClass: argument: currentClass theNonMetaClass]
		ifFalse: [ menu add: 'class side' selector: #setMethodsClass: argument: currentClass class].

	superc isEmpty ifFalse: [
		smenu _ MenuMorph new defaultTarget: self.
		superc do: [:eachClass |
			smenu add: eachClass printString selector: #setMethodsClass: argument: eachClass ].
		menu add: 'superclasses' subMenu: smenu ].

	subc isEmpty ifFalse: [
		smenu _ MenuMorph new defaultTarget: self.
		subc do: [:eachClass |
			smenu add: eachClass printString selector: #setMethodsClass: argument: eachClass ].
		menu add: 'subclasses' subMenu: smenu].

	menu addLine.

	packages keys asSortedCollection do: [:eachPkg |
		pkgMenu _ MenuMorph new.
		(packages at: eachPkg) asSortedCollection do: [: cat |
			catMenu _ self menuForCategory: cat.
			pkgMenu add: (SyntaxElementMorph wordsFrom: cat asString)
					subMenu: catMenu ].
		menu add: eachPkg subMenu: pkgMenu ].

	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:23'!
classMenu
	| menu |
	menu _ MenuMorph new.
	menu defaultTarget: self.
	menu defaultTarget: self.
	menu add: 'in package' action: #currentPackageClasses.
	menu add: 'all' action: #allClasses.
	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:40'!
classVars
	choice _ #classVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/8/2009 23:38'!
classes
	choice _ #currentPackageClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:04'!
currentMessages
	choice _ #currentMessages.
	lastMsgChoice _ choice.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 23:05'!
currentMethodsClass

	^(self ownerThatIsA: ElementsPaletteFrameMorph) currentMethodsClass.
	! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:25'!
currentPackageClasses
	choice _ #currentPackageClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:24'!
frame: aMorph
	frame _ aMorph! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:40'!
globalVars
	choice _ #globalVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:12'!
initialize
	super initialize.
	choice _ #basics.
	lastMsgChoice _ #currentMessages.
	color _ Color gray.
	self width: 180.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:39'!
instanceVars
	choice _ #instanceVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:52'!
menuForCategory: categoryName

	|menu list submenu |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ SystemOrganization listAtCategoryNamed: categoryName.
	list asSortedCollection do: [:eachClass|
		submenu _ MenuMorph new defaultTarget: self.
		submenu add: 'instance' selector: #setMethodsClass: argument: (Smalltalk classNamed: eachClass).
		submenu add: 'class' selector: #setMethodsClass: argument: (Smalltalk classNamed: eachClass) class.
		menu add: (SyntaxElementMorph wordsFrom: eachClass asString) subMenu: submenu].
	^menu
! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:05'!
messages
	choice _ lastMsgChoice.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:56'!
methodsClass
	^methodsClass! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:33'!
refresh
	basics off.
	classes off.
	messages off.
	variables off.

	(#basics = choice) ifTrue: [
		basics on ].
	(#(allClasses currentPackageClasses) includes: choice) ifTrue: [
		classes on ].
	(#(variables instanceVars classVars globalVars) includes: choice) ifTrue: [
		variables on ].
	(#(currentMessages methodsClass) includes: choice) ifTrue: [
		messages on ].

	frame ifNotNil: [frame refresh]! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:04'!
setMethodsClass: aClass
	choice _ #methodsClass.
	lastMsgChoice _ choice.
	methodsClass _ aClass.
	self refresh	! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:48'!
varMenu
	| menu isClassSide |
	menu _ MenuMorph new.
	menu defaultTarget: self.
	isClassSide _ frame currentClass isKindOf: Metaclass.
	isClassSide ifFalse: [
		menu add: 'instance' action: #instanceVars ].
	menu add: 'class' action: #classVars.
	menu add: 'globals' action: #globalVars.
	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:16'!
variables
	choice _ #variables.
	self refresh! !


ElementsButtonMorph subclass: #TriangleButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!TriangleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:08'!
borderColorDark
	^owner color twiceDarker! !

!TriangleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:08'!
borderColorLight
	^owner color twiceLighter lighter! !

!TriangleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:09'!
borderColorVeryDark
	^owner color twiceDarker darker! !

!TriangleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:08'!
borderColorVeryLight
	^owner color twiceLighter twiceLighter lighter! !

!TriangleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:18'!
drawOn: aCanvas
	aCanvas
		line: self topLeft + 1 to: (self topRight + (-1@1)) color: self borderColorVeryLight;
		line: (self topRight + (-1@1)) to: (self center x @ (self bottom - 1)) color: self borderColorVeryDark;
		line: self center x @ (self bottom - 1) to: self topLeft + 1 color: self borderColorLight
! !
