CSlotMorph subclass: #CArgSlotMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/8/2010 23:07'!
blockWidth

	| bw |
	bw _ 0.
	(owner isKindOf: BlockMorph) ifTrue: [
		bw _ owner width].
	^ 50 max: bw! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 23:52'!
drawBottomBarOn: aCanvas 


	| left barTop barBottom |

	barBottom _ self bottom.


	barTop _ barBottom - 3.
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		aCanvas
			fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
			color: shadowColor]

! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/8/2010 22:50'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas


! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 23:52'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.

	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 1 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		self drawPoint: (right "- 1")@y color: shadowColor on: aCanvas.
		self drawPoint: (right - 1 "2")@(y + 1) color: shadowColor on: aCanvas]
! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:45'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.

	aCanvas

		fillRectangle: (self topLeft corner: (barRight @ self bottom))
		color: color;

		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.
! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 7/6/2010 21:37'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [self color: owner color]].

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	newH _ self topBarHeight + 14.

	nestedBlock
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ nestedBlock fullBounds height + 2.
			nestedBlock position: self position + (CBlockBracketThickness @ (self topBarHeight)).
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	self height: newH.


	(owner isKindOf: ReporterBlockMorph) 
		ifTrue: [nestedBlock ifNotNil: [
			self width: nestedBlock fullBounds width + CBlockBracketThickness]]

! !


!CArgSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/9/2010 02:19'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ result _ result copyWith: ((self topLeft + (CBlockBracketThickness@(self topBarHeight + 3))) -> self)]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.

! !

!CArgSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/9/2010 02:20'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #loopLambda! !


!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:02'!
ensureSlotWidth: width
"This is a special slotted block and we want to make sure of its width."

	self width: width.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:13'!
morphEndsLine
"This morph should be the only one on its line (not counting children)."

	^ true.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:13'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children)."

	^ false.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:45'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self width: linewidth - 5.! !
