Morph subclass: #ClassChooserMorph
	instanceVariableNames: 'class label button frame '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 21:58'!
chooseClass

	|menu list packages pkg pkgMenu catMenu |
	packages _ Dictionary new.
	SystemOrganization categories asSortedCollection do: [:cat |
		pkg _ (cat asString findTokens: #( $- )) first.
		(packages includesKey: pkg)
			ifFalse: [ packages at: pkg put: OrderedCollection new].
		(packages at: pkg) add: cat].

	menu _ MenuMorph new.
	packages keys asSortedCollection do: [:eachPkg |
		pkgMenu _ MenuMorph new.
		(packages at: eachPkg) asSortedCollection do: [: cat |
			catMenu _ self menuForCategory: cat.
			pkgMenu add: (self wordsFrom: cat asString)
					subMenu: catMenu ].
		"pkgMenu add: (self wordsFrom: eachPkg asString)
				subMenu: pkgMenu."
		menu add: eachPkg subMenu: pkgMenu ].



"
	list _ SystemOrganization categories asSortedCollection.
	list do: [:each|
		menu add: (self wordsFrom: each asString) subMenu: (self menuForCategory: each)].
"
	menu popUpAt: button center x @ (self bottom + 5) forHand: World activeHand! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 12:30'!
class: aClass
	| classToSet |
	classToSet _ aClass.

	frame ifNotNil: [
		(frame currentSide = #class)
		& (aClass isKindOf: Metaclass) not
			ifTrue: [ classToSet _ aClass class ]].

	class = classToSet ifTrue: [^self].
	class _ classToSet.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	label contents: (self wordsFrom: class name asString).
	self fitMorphs.

	frame ifNotNil: [
		frame selectClass: class]! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:21'!
fitMorphs
	button extent: (label height @ label height) * 2//3.
	button position: self left @ self top + (label height - button height // 2).
	label position: (button right + (button width // 3)) @ self top.
	self extent: label bottomRight - self position! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 22:06'!
frame: aMorph
	frame _ aMorph! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:34'!
handlesMouseDown: evt
	^ true
! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:20'!
initialize
	super initialize.
	self color: Color gray.
	self addMorph: (button _ TriangleButtonMorph new
				target: self;
				selector: #chooseClass)
	! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:46'!
labelColor
	^Color white! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:23'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 12! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:41'!
menuForCategory: categoryName

	|menu list |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ SystemOrganization listAtCategoryNamed: categoryName.
	list asSortedCollection do: [:each|
		menu add: (self wordsFrom: each asString) selector: #class: argument: (Smalltalk classNamed: each)].
	^menu
! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:35'!
mouseDown: evt
	self chooseClass! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 08:33'!
selectedClass
	^class! !

!ClassChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 22:09'!
wordsFrom: camelCase
	^SyntaxElementMorph wordsFrom: camelCase
! !
