ElementsButtonMorph subclass: #ElementsToggleButtonMorph
	instanceVariableNames: 'onColor offColor label on specialEffect '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:50'!
drawOn: aCanvas 

	|r bw |
	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color.
"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self bottomRight - bw)) color: color.

"

specialEffect ifTrue: [

	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self left + self height) @ (self center y - bw)) color: onColor twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self left + self height) @ (self center y)) color: onColor lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self left + self height) @ (self bottom - bw)) color: onColor


]! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:42'!
fitMorphs
	| bw x y |
	bw _ self borderWidth.
	self height: label height + (bw * 2).
	x _ self left + ((self width - label width) // 2).
	y _ self top + bw.
	label position: x@ y ! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:49'!
flat
	specialEffect _ false! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:49'!
initialize
	super initialize.
	specialEffect _ true.
	on _ true.
	target _ self.
	selector _ #toggle.
	onColor _ Color blue.
	offColor _ Color gray.
	self label: 'Elements Toggle Button'.
	self toggle! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
isOn
	^on! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:03'!
label: aString

	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	label contents: aString.
	self fitMorphs
! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:47'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 10! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
off
	on _ false.
	self color: offColor! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/3/2009 23:54'!
on
	on _ true.
	self color: onColor! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 01:24'!
onColor: onc offColor: offc
	onColor _ onc.
	offColor _ offc! !

!ElementsToggleButtonMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 00:07'!
toggle
	self fitMorphs.
	on ifTrue: [^self off].
	self on! !
