CommandBlockMorph subclass: #CustomCommandBlockMorph
	instanceVariableNames: 'userSpec isTemplate specParts isFrozen extraSpaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!
!CustomCommandBlockMorph commentStamp: '<historical>' prior: 0!
some code which could be useful:

| hat template |
hat _ WhenHatBlockMorph new.
hat submorphs do: [:m | (m isKindOf: StringMorph) ifTrue: [m delete]].
template _ CommandBlockMorph new commandSpec: 'this is a long, long road to go down'.
hat replaceArgMorph: hat argMorph by: template.
hat openInWorld


!


!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
allVarNames
	^self definition allVarNames! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 23:31'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping block could be attached."

	isTemplate
		ifTrue: [^#()]
		ifFalse: [ super blockAttachPoints: aSet ]
		! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/30/2010 23:58'!
category

	| def |
	def _ self definition.
	def ifNil: [^#none].
	^ def category! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'CWB 7/23/2011 17:02'!
copyUserBlockSpec
	"Copies the specification of the current user block onto the clipboard"
	| spec |

	spec _ self userSpec.
	
	ParagraphEditor clipboardTextPut: spec asText.
	ScratchTranslator unicodeClipboardPut: spec.! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2010 02:10'!
defaultArgs: defaultValues
	"Set the default values of my arguments from the given list."

	self setDefaultArgs! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:02'!
definition
	^receiver definitionFor: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:20'!
deleteDefinition
	receiver deleteDefinitionId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 23:32'!
editScript
	receiver editScriptId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:44'!
editSpec
	(World allMorphs detect: [:m| m isKindOf: BlockDialog] ifNone: [nil])
		ifNotNil: [^self].
	receiver editSpecId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:00'!
fieldsVersion

	^ 1
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/18/2010 02:04'!
firstBlockList

	self script
		ifNil: [^ #()]
		ifNotNil: [^ self script blockSequence "collect: [:each | each fullCopy]"]. "added #fullCopy for lambda variable support. -JM"

	 "old code taken out for speed, now the copying is done in #doApplyEval"! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:02'!
initFieldsFrom: anObjStream version: classVersion

	super initFieldsFrom: anObjStream version: classVersion.
	self initFieldsNamed: #(
		userSpec
	) from: anObjStream.

! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:03'!
initialize
	super initialize.
	isTemplate _ false.
	isFrozen _ false.
	isSpecialForm _ true.
	self color: Color lightGray! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
isAtomic
	^self definition isAtomic! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 04:03'!
isCustomBlock
	^true! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:20'!
isFunction
	^ false! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 16:19'!
isReporter
	^false! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:58'!
parameterNames
	^self definition parameterNames! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/1/2010 14:13'!
privateSetUserSpec: aString

	userSpec _ aString.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 18:38'!
remove
	|nb sm|
	nb _ self nextBlock.
	(self ownerThatIsA: BlockEditorFrameMorph) isNil
		ifTrue: [
			sm _ self ownerThatIsA: ScratchScriptsMorph.
			(nb notNil & sm notNil) ifTrue: [sm addMorph: nb]]
		ifFalse: [
			sm _ self owner.
			(nb notNil & sm notNil) ifTrue: [sm nextBlock: nb]].
	self delete! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/16/2010 16:37'!
rename

	| def defs choice menu |
	def _ self definition.
	defs _ receiver customBlocks select: [:eachDef |
		eachDef ~= def and: [
			eachDef type = def type and: [
				eachDef category = def category ]]].
	defs _ defs asSortedCollection: [:x :y |
		x id <= y id].
	menu _ CustomMenu new.
	defs do: [:eachDef |
		menu addIcon: (receiver lambda: eachDef id) imageForm toolTip: nil action: eachDef].
	choice _ menu startUp: nil withCaption: nil at: self topRight.
	choice ifNil: [^ self].
	self userSpec: choice userSpec! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/3/2010 22:17'!
replaceArgMorph: argMorph by: newMorph

	| def typ pname i val |
	super replaceArgMorph: argMorph by: newMorph.
	(newMorph isKindOf: ExpressionArgMorph) ifTrue: [
		def _ self definition.
		i _ argMorphs indexOf: newMorph.
		pname _ def parameterNames at: i.
		typ _ def typeOf: pname.
		val _ def defaultOf: pname.
		#number = typ
			ifTrue: [newMorph numExpression: val] 
			ifFalse: [newMorph defaultValue: val]]! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'CWB 7/25/2011 22:44'!
rightButtonMenu

	| menu choice |
	menu _ CustomMenu new.

	DebugMenu ifTrue: [ "developer menu"
		| customSpec |
		customSpec _ self userSpec.
		menu add: 'Custom block: id = ', self id asString asString action: #nil.
		menu add: 'Copy spec: ', customSpec action: #copyUserBlockSpec.
		menu addLine.
	].

	menu add: 'help' action: #presentHelpScreen.
	menu addLine.
	isTemplate 
		ifTrue: [menu add: 'change category' action: #editSpec ]
		ifFalse: [menu add: 'edit' action: #editScript].

	((owner isKindOf: ScratchBlockPaletteMorph) or: [isTemplate]) ifFalse: [
		menu add: 'relabel' action: #rename.
		menu addLine.
		menu add: 'duplicate' action: #duplicate.
		menu add: '- this block' action: #fastDuplicate.

		(self owner isKindOf: BlockMorph) ifFalse: [  "can't yet delete a blocks inside a script"
			menu add: 'delete' action: #delete]].

	(owner isKindOf: ScratchBlockPaletteMorph) ifTrue: [
		menu add: 'delete block definition' action: #deleteDefinition ].

	(choice _ menu localize; startUp) ifNil: [^ self].
	self perform: choice.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
script
	^self definition body! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 02:28'!
sequence
	^self firstBlockList! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/14/2010 21:55'!
setDefaultArgs

	| a def parms typ |

	def _ self definition.
	parms _ def parameterNames.
	1 to: argMorphs size do: [:i |
		a _ argMorphs at: i.
		(a isKindOf: ArgMorph) ifTrue: [
			(a isKindOf: MultiArgMorph)
				ifTrue: [a addArgSlot]
				ifFalse: [
					typ _ def typeOf: (parms at: i ifAbsent: [nil]).
					#number = typ
						ifTrue: [a numExpression: (def defaultOf: (parms at: i ifAbsent: [nil]))]
						ifFalse: [a defaultValue: (def defaultOf: (parms at: i ifAbsent: [nil]))]]]]! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/30/2008 11:03'!
start
	isTemplate ifTrue: [^self].
	super start! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:01'!
storeFieldsOn: anObjStream

	super storeFieldsOn: anObjStream.
	self storeFieldsNamed: #(
		userSpec
	) on: anObjStream.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 11:27'!
userSpec
	^userSpec! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/16/2010 02:55'!
userSpec: aString
	| cat def |

	userSpec _ aString.
	isTemplate ifTrue: [self removeVariableTemplates].
	cat _ self category.
	cat ifNotNil: [
		self color: (ScriptableScratchMorph blockColorFor: cat asString) ].
	def _ receiver definitionFor: self id.
	def ifNil: [^ self].
	self commandSpec: def commandSpec.
	self addLabel! !


!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/27/2010 22:06'!
addLabel

	| tokens args nextArgIndex m next part frontSpace backSpace |
	commandSpec ifNil: [^ self].

	isTemplate ifFalse: [
		^ self addLabelToNonTemplate].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ commandSpec findTokens: ' '.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove any excess arg morphs from the list."
	[argMorphs size > args size] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))].

	nextArgIndex _ 1.

	extraSpaces _ Array new: 2.

	"insert a place holder on front"
	frontSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 1 put: frontSpace.
	self addMorphBack: frontSpace.


	specParts _ OrderedCollection new.
	part _ ArgumentPlaceHolderMorph new.
	self addMorphBack: part.
	specParts add: part.
	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m.
		specParts add: m.
		part _ ArgumentPlaceHolderMorph new.
			self addMorphBack: part.
			specParts add: part ].

	"insert another place holder at the back"
	backSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 2 put: backSpace.
	self addMorphBack: backSpace.

	self isReporter ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	self addVariableTemplates.
	self hideArgumentPlaceHolders! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/5/2010 00:46'!
addLabelToNonTemplate
	"Add a label for my command and arguments. This is the method that really creates the whole block."

	| tokens args nextArgIndex m next argValues eachArg eachValue pn pt def |
	commandSpec ifNil: [^ self].

	"remember the values of the arguments"
	argValues _ OrderedCollection new.
	argMorphs do: [:a |
		(a isKindOf: BlockMorph)
			ifTrue: [argValues add: a]
			ifFalse: [(a isKindOf: MultiArgMorph)
				ifTrue: [argValues add: a listValue]
				ifFalse: [(a isKindOf: ExpressionArgMorph)
					ifTrue: [ a isNumberExpression
						ifTrue: [a getExpression = ' ' asUTF8
							ifTrue: [argValues add: a getExpression]
							ifFalse: [argValues add: a getExpression asNumberNoError]]
						ifFalse: [argValues add: a getExpression]]
					ifFalse: [a isEmptySlot
						ifFalse: [argValues add: a evaluate]]]]].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ CommandBlockMorph parseCommandSpec: commandSpec.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove all arg morphs from the list."
	[argMorphs size > 0 ] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		def _ self definition.
		def isNil
			ifTrue: [pt _ #any]
			ifFalse: [ pt _ def typeOfParameterIndex: argMorphs size + 1].
		#template = pt 
			ifTrue: [
				pn _ def parameterNames at: argMorphs size + 1.
				argMorphs addLast: 	(VariableBlockMorph new 
					isSpecialForm: true; 
					selector: #getVar:;
"					color: (ScriptableScratchMorph blockColorFor: 'variables');"
					commandSpec: pn)]
			ifFalse: [argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))]].

	nextArgIndex _ 1.

	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m].

	(self isReporter and: [submorphs isEmpty not]) ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	"now try restoring the former arguments (jens)"
	1 to: argMorphs size do: [:i |
		eachArg _ argMorphs at: i.
		eachValue _ argValues at: i ifAbsent: [nil].
		eachValue ifNotNil: [(eachValue isKindOf: BlockMorph)
			ifTrue: [(eachArg acceptsTypeOf: eachValue)
				ifTrue: [ (({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachArg class) and: [eachArg class = eachValue class])
					ifTrue: [self replaceArgMorph: eachArg by: eachValue]
					ifFalse: [({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachValue class)
						ifTrue: [((eachArg respondsTo: #attachBlock:) and: [(eachValue respondsTo: #nestedBlock) and: [eachValue nestedBlock notNil]])
							ifTrue: [eachArg attachBlock: eachValue nestedBlock]]
						ifFalse: [self replaceArgMorph: eachArg by: eachValue]]]
				ifFalse: [((eachArg isKindOf: VariableBlockMorph) and: [
							eachValue isKindOf: VariableBlockMorph])
								ifTrue: [eachArg commandSpec: eachValue commandSpec]]]
			ifFalse: [ 
				((eachArg isKindOf: ExpressionArgMorph) and: [eachArg isNumberExpression])
					ifTrue: [eachArg defaultValue: eachValue "asNumberNoError"]
					ifFalse: [ (eachValue isKindOf: ScratchListMorph)
						ifTrue: [eachArg defaultValue: eachValue]
						ifFalse: [eachArg defaultValue: eachValue asString]]]]]


! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 8/2/2010 21:47'!
addVariableTemplates
	| parms varBlock idx |
	parms _ self definition parameterNames.
	1 to: parms size do: [: i |
		varBlock _ VariableBlockMorph new. 
		varBlock
			isSpecialForm: true;
			receiver: self definition;
			selector: #getBlockVar:;
			commandSpec: (parms at: i);
"			color: (ScriptableScratchMorph blockColorFor: 'variables');"
			updateFragment;
			parameterType: (self definition typeOf: (parms at: i));
			parameterDefaultValue: (self definition defaultOf: (parms at: i));
			yourself.
		idx _ specParts indexOf: (self argumentAt: i).
		idx > 0 ifTrue: [ specParts at: idx put: varBlock].
		self replaceArgMorph: (self argumentAt: i) by: varBlock.
		varBlock addLabel]

! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/2/2010 00:21'!
getDnDSpec
	| s |
	s _ ''.
	specParts do: [:part | 
		s _ s, ' ', (part labelFragment spec) asMacRoman].
	^s withoutLeadingBlanks asUTF8! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/24/2008 15:22'!
handleTool: toolName hand: hand
	isTemplate ifFalse: [super handleTool: toolName hand: hand ]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 2/15/2010 22:35'!
hideArgumentPlaceHolders

	isFrozen ifTrue: [^ self].
	extraSpaces ifNotNil: [
		extraSpaces do: [:each |
			each extent: ArgumentPlaceHolderMorph dimensions ]].
	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m vanish]]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 23:07'!
isFrozen
	^ isFrozen! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 23:04'!
isFrozen: bool
	isFrozen _ bool! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 16:08'!
isPartsBin
	^isTemplate! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/9/2008 08:39'!
isTemplate
	^isTemplate! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 16:00'!
isTemplate: aBoolean
	isTemplate _ aBoolean! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/27/2010 21:41'!
labelMorphFor: aString

	| s |

	isTemplate ifFalse: [^super labelMorphFor: aString].

	s _ aString.
	commandSpec isUnicode ifTrue: [s _ UTF8 withAll: s].
	^ (BlockLabelFragmentMorph contents: s font: (ScratchFrameMorph getFont: #Label))
		color: self labelColor;
		updateFragment;
		yourself
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 12/4/2009 01:06'!
removeParameter: varBlock

	| idx |
	idx _ specParts indexOf: varBlock.
	idx = 0 ifTrue: [^self].
	specParts at: idx put: ArgumentPlaceHolderMorph new.
	self updateSpecWithDnDSpec! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 18:28'!
removeVariableTemplates
	argMorphs do: [:each| each delete ].
	argMorphs _ OrderedCollection new! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/1/2010 22:49'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nextBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].
	(isTemplate and: [ 
		owner isKindOf: ProcedureHatBlockMorph]) 
			ifTrue: [^nil].

	^ super rootForGrabOf: aMorph
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 19:59'!
showArgumentPlaceHolders

	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m appear]]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/30/2010 14:09'!
showEdgePlaceHolders

	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces ifNil: [^ self].
	extraSpaces do: [:each |
		each extent: 0@0].
	
	specParts first appear.
	specParts last appear.
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/24/2010 23:34'!
showPlaceHoldersNear: aLabelFragment

	| idx |
	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces do: [:each |
		each extent: 0@0].
	
	idx _ submorphs indexOf: aLabelFragment.
	(submorphs at: idx - 1) appear.
	(submorphs at: idx + 1) appear.

	(aLabelFragment isKindOf: VariableBlockMorph)
		ifFalse: [aLabelFragment color: color twiceDarker]


! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/15/2010 00:38'!
updateSpecWithDnDSpec
	"the spec has been changed by way of drag'n'drop (Jens' design) 
	or direct editing (Brian's design).

	We need to:

	1.	determine the new command spec
	2. 	check for input constraints
	3.	determine the new parameters and their types (declarations) and defaults
	4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition
	7.	update the Block Editor
	8.	update the Scratch Window
"

	| newSpec parms defaults oldid newid types def  stage affected eachDef be sf |

	"1.	determine the new command spec"

	def _ self definition.
	def ifNil: [^self].
	oldid _ self id.

	newSpec _ self getDnDSpec. 
	newSpec isEmpty ifTrue: [
		self addLabel.
		^ self ].	

	newid _ CustomBlockDefinition idFromSpec: newSpec. 

	"2. 	check for input constraints"

	parms _ def parameterNamesInSpec: newSpec.
	parms size > parms asSet size ifTrue: [
		DialogBoxMorph warn: 'a parameter with that label already exists'.
		self addLabel.
		^ self ].	

	((newid ~= oldid) and: [receiver existsBlockId: newid global: def isGlobal]) ifTrue: [
		DialogBoxMorph warn: 'a block with that label already exists'.
		self addLabel.
		^ self ].	

	"3.	determine the new parameters and their types (declarations) and defaults"

	types _ Dictionary new.
	defaults _ Dictionary new.
	(specParts select: [:part | part labelFragment isInput ]) do: [:m |
		types at: m labelFragment label put: m labelFragment type.
		defaults at: m labelFragment label put: m labelFragment default ].

	"4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition"

	stage _ receiver ownerThatIsA: ScratchStageMorph.

	def isGlobal not | stage isNil
		ifTrue: [
			def
				declarations: types;
				defaults: defaults.
			affected _ receiver instancesOf: oldid.
			def userSpec: newSpec.
			affected do: [:eachBlock|
				eachBlock
					privateSetUserSpec: newSpec;
					commandSpec: def commandSpec]]
		ifFalse: [
			stage sprites, {stage} do: [:obj | 
				eachDef _  obj definitionFor: oldid.
				eachDef ifNotNil: [
					eachDef
						declarations: types copy;
						defaults: defaults copy.
					affected _ obj instancesOf: oldid.
					eachDef userSpec: newSpec.
					affected do: [:eachBlock|
						eachBlock
							privateSetUserSpec: newSpec;
							commandSpec: eachDef commandSpec]]]].

	"7.	update the Block Editor"

	be _ self ownerThatIsA: BlockEditorFrameMorph.

	be definition
		declarations: types copy;
		defaults: defaults copy;
		userSpec: newSpec.

	affected _ be instancesOf: oldid.
	affected do: [:eachBlock|
		eachBlock
			privateSetUserSpec: newSpec;
			commandSpec: def commandSpec].

	"8.	update the Scratch Window"

	sf _ receiver ownerThatIsA: ScratchFrameMorph.
	sf viewerPane categoryChanged: 'variables'.
	#none = def category ifFalse: [
		sf viewerPane categoryChanged: def category asString ]
! !


!CustomCommandBlockMorph methodsFor: 'stack/tuple conversion' stamp: 'jens 7/20/2010 23:07'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple argList arg val eval |
	blockTuple _ Array new: argMorphs size + 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: userSpec.

	argList _ argMorphs.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [(arg isKindOf: MultiArgMorph)
				ifTrue: [ blockTuple at: i + 4 put: arg listValue convertStacksToTuples] "a list"
				ifFalse: [ ((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
					ifTrue: [blockTuple at: i + 4 put: arg asBlockTuple]
					ifFalse: [(arg isKindOf: ExpressionArgMorph)
						ifTrue: [
							val _ arg getExpression.
							arg isNumberExpression
								ifTrue: [val = ' ' asUTF8
									ifTrue: [eval _ val]
									ifFalse: [eval _ val asNumberNoError]]
								ifFalse: [eval _ arg getExpression]]
						ifFalse: [eval _ arg evaluate].
						blockTuple at: i + 4 put: eval]]]
			ifFalse: [blockTuple at: i + 4 put: arg asBlockTuple]].
	^ blockTuple
! !


!CustomCommandBlockMorph methodsFor: 'identification' stamp: 'jens 1/14/2010 20:36'!
id
	^CustomBlockDefinition idFromSpec: userSpec! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CustomCommandBlockMorph class
	instanceVariableNames: ''!

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 5/21/2010 03:14'!
codeOwner
	^ 'jens owns the byob code :-)'! !

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 5/21/2010 02:39'!
owner
	^ 'jens'! !

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 9/23/2008 17:45'!
template
	^self new isTemplate: true! !
