NXTSensor subclass: #NXTLightDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTLightDetector commentStamp: '<historical>' prior: 0!
For light sensors (and color sensors) that also have lamps (LEDs that turn on and off).  This is actually like the LampLightDetector interface in LeJOS, not, as the name suggests, like LightDetector.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTLightDetector class
	instanceVariableNames: ''!

!NXTLightDetector class methodsFor: 'accessing' stamp: 'CWB 11/20/2010 20:21'!
baseName

	^ 'light sensor'! !

!NXTLightDetector class methodsFor: 'accessing' stamp: 'CWB 11/22/2011 16:20'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."


	^ #(
		'NXT Light Sensor'
		'NXT Color Sensor'
		'HiTechnic Color Sensor'
		'RCX Light Sensor'
	).! !


!NXTLightDetector class methodsFor: 'block specs' stamp: 'CWB 11/23/2011 18:37'!
configBlockSpec

	^ 'Measures brightness or color using a %p named %s.'
	"^ 'Measures brightness using a %p named %s.'."! !

!NXTLightDetector class methodsFor: 'block specs' stamp: 'CWB 11/12/2011 15:58'!
obsoleteBlocks
"Returns a list of blocks that used to be provided by this block but have been deprecated and should not be used in the future.  These blocks will still load from files, but can not be freshly created in new programs, and need not be translated"

	| blocks |
	
	blocks _ #(
		'sensing'
			('%P sees light?' 				b	NXTLightDetector:seesLight:)
			('turn %P''s lamp %Q'			-	NXTLightDetector:setLightColor:)
		).

	^ blocks  ! !

!NXTLightDetector class methodsFor: 'block specs' stamp: 'CWB 11/24/2011 16:09'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks.  Note that the 'selectors' are all unique, start with the class name followed by a colon, but do not actually have functions that go with them."

	| blocks |
	
	blocks _ #(
		'sensing'
			('%P sees %c'					b	NXTLightDetector:seesColor:)
			('%P %J' 						r	NXTLightDetector:sensor:param:)	"brightness"
			('%P color'						r	NXTLightDetector:color)
			('set %P''s lamp %c'				-	NXTLightDetector:setLightColor2:)
			'-'
			('%P set %K to %n' 				-	NXTLightDetector:sensor:param:set:)
			('start auto-calibrating %P'		-	NXTLightDetector:startAutoCalibration:)
			('auto-calibrate %P to include current reading'	-	NXTLightDetector:addReadingToCalibration)
		'list'
			('%c as HSV list'					r	NXTLightDetector:colorAsHSBList:)
			('%J of %c'						r	NXTLightDetectorX1:hsbSelector:)
		).

	^ blocks  ! !


!NXTLightDetector class methodsFor: 'dropdown lists' stamp: 'CWB 11/24/2011 13:44'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"Things that can be read from the sensor or its settings"
		^ #('brightness' 'raw value' 'darkest point' 'brightest point')	
	].
	(aNumber = 2) ifTrue: [
		"Things you can set on the sensor"
		^ #('darkest point' 'brightest point')	
	].

	" obsolete "
	(aNumber = 3) ifTrue: [
		"Turn the lamp off or on (possibly with a color)"
		^ #('on (red)' 'on (green)' 'on (blue)' 'off (ambient)')	
	].

	^ nil.! !
