MultiArgReporterBlockMorph subclass: #LambdaBlockMorph
	instanceVariableNames: 'parameters variables initialFrame type declarations isAtomic '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 5/4/2010 23:34'!
displayBlock

	| top b ans|

	b _ self optimized body.
	b ifNil: [^self fullCopy].

	parameters isEmpty ifTrue: [ 
		self optimized sequence first selector = #doAnswer ifTrue: [
			ans _ self optimized sequence first argMorphs first fullCopy.
			(ans isKindOf: ArgMorph) ifTrue: [^self].
			(ans isKindOf: CommandScriptBlockMorph) ifFalse: [
				ans allMorphs do: [:m | (m isKindOf: BlockMorph) ifTrue: [
						m isContrasted: false; addLabel]].
					^ ans]].
			^b].

	top _ self parameterTopBlock.
	top attachBlock: b.
	^top! !

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 4/14/2010 00:25'!
displayForm

	| block |

	block _ self displayBlock.
	block allMorphs do: [:m |
		(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout ]].
	^ block imageForm withOutlineColor: ScratchFrameMorph scriptsPaneColor width: 4! !

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 8/4/2010 03:44'!
parameterTopBlock
	"private - for display purposes only"

	| block arg |
	block _ CommandBlockMorph new.
	block color: Color lightGray.
	block commandSpec: 'input names:' localized.

	parameters do: [:p |
		arg _ ReporterBlockMorph new.
		arg color: VariableFrame variableBlockColor.
		arg commandSpec: p.
		block addArg: arg].

	^ block


! !


!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 00:10'!
addVariable

	| ans |
	ans _ StringDialog askWithCancel: 'New Block Variable Name' initialAnswer: ''.
	ans isEmpty ifTrue: [^false].
	(self allVarNames includes: ans) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	variables add: ans.
	initialFrame add: ans.
	self rightButtonMenu! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 22:53'!
allVarNames
	^ (parameters, variables) asSortedCollection! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:36'!
bind: varName to: varFrame as: alias

	"for externalized local variables"

	self privateBody allMorphsDo: [:m |
		(m isKindOf: VariableBlockMorph) ifTrue: [
			m variable = varName ifTrue: [
				m
					receiver: varFrame;
					alias: alias ]]]! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 21:57'!
body
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2011 00:32'!
checkBoxLabelled: aString marked: aBool width: anInt
	"answer a form consisting of a checkbox and a label - used for the EDIT menu in BYOB"

	| box label pic line cnts |
	aBool
		ifTrue: [pic _ ScratchFrameMorph skinAt: #watcherButtonPressed]
		ifFalse: [pic _ ScratchFrameMorph skinAt: #watcherButton].
	box _ ImageMorph new form: pic. 
	
	ScratchTranslator useSqueakRendering
		ifTrue: [cnts _ ' ', aString localized asMacRoman]
		ifFalse: [cnts _ ' ' asUTF8, aString localized].

	label _ StringMorph contents: cnts font: Preferences standardMenuFont.
	line _ Morph new color: Color transparent.
	line height: (box height max: label height).
	line width: (box width + label width max: anInt).
	box left: line left.
	box top: line top + (line height - box height // 2).
	label left: box right.
	label top: line top + (line height - label height // 2).
	line addMorph: box.
	line addMorph: label.
	^ line imageForm

! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:53'!
declarations
	^declarations! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:53'!
declarations: aDictionary
	declarations _ aDictionary! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 04:39'!
evaluate
	^self optimized! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: rawArgs

	^self optimized! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:10'!
fixInitialFrame
	initialFrame _ VariableFrame forNames: self allVarNames.
	self allMorphsDo: [:m |
		((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph)
		and: [m isSpecialForm & (initialFrame scope includes: m variable)]) ifTrue: [
			m receiver: initialFrame ]]! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:43'!
initialFrame: aVariableFrame
	initialFrame _ aVariableFrame! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:16'!
initialize
	super initialize.
	type _ #none.
	parameters _ OrderedCollection new.
	variables _ OrderedCollection new.
	declarations _ Dictionary new.
	isAtomic _ false.
	initialFrame _ VariableFrame new! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:18'!
isAtomic
	^ isAtomic! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:18'!
isAtomic: aBoolean
	isAtomic _ aBoolean! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 23:08'!
isBooleanFunction
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:17'!
isFunction
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 20:33'!
isLambdaForm
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 20:34'!
isPartsBin
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/6/2010 01:34'!
morphToShow
"	^ self body ifNil: [self]"

	^ImageMorph new form:  self displayForm! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newChangeVarBlock: varName

	| block |
	block _ SetterBlockMorph new
		initChangerForVar: varName;
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #changeBlockVar:by: ";
		color: (ScriptableScratchMorph blockColorFor: 'variables')".
	block expressionArg stringExpression: '0'.
	^ block
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newSetVarBlock: varName

	| block |
	block _ SetterBlockMorph new
		initSetterForVar: varName;
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #setBlockVar:to:  ";
		color: (ScriptableScratchMorph blockColorFor: 'variables')".
	block expressionArg stringExpression: '0'.
	^ block
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newVarBlock: varName

	^ VariableBlockMorph new
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #getBlockVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: varName
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 11:22'!
optimized
	^ (self fullCopy)
		fixInitialFrame! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 01:52'!
parameterNames
	^ parameters! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 02:34'!
parameters
	^ parameters! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
parameters: anOrderedCollection
	 parameters _ anOrderedCollection! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:32'!
privateBody
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:09'!
removeLastArg

	| idx |
	idx _ argMorphs size.
	(argMorphs at: idx) delete.
	argMorphs at: idx put: nil.
	initialFrame remove: parameters last.
	parameters removeLast.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 00:53'!
removeVariable
	| ans |
	ans _ (SelectionMenu selections: variables asSortedCollection) startUp.
	ans ifNil: [^false].
	variables remove: ans.
	initialFrame remove: ans.
	variables isEmpty ifFalse: [
		self rightButtonMenu]
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 01:19'!
renameParm: old to: new

	(self allVarNames includes: new) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	initialFrame renameVar: old to: new.
	parameters at: (parameters indexOf: old) put: new.
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2011 00:31'!
rightButtonMenu

	| menu choice block vn atomic |

	"first create the widest label"

	atomic _ self checkBoxLabelled: 'atomic'
				marked: self isAtomic
				width: 0.

	menu _ CustomMenu new.
	menu add: 'help' action: #presentHelpScreen.
	menu addLine.
	menu add: 'duplicate' action: #duplicate.
	(self owner isKindOf: BlockMorph) ifFalse: [  "can't yet delete a blocks inside a script"
		menu add: 'delete' action: #delete].
	menu addLine.

	menu addIcon: atomic
			toolTip: 'execute as single block'
			action: #toggleAtomicity.


"
	menu add: (isAtomic ifTrue: ['atomic -> interleafed'] ifFalse: ['interleafed -> atomic']) action: #toggleAtomicity.
"

	"menu add: 'make a block variable' action: #addVariable.
	variables isEmpty ifFalse: [
		menu add: 'delete a bock variable' action: #removeVariable.
		menu addLine.
		variables asSortedCollection do: [:vName |
			menu addIcon: (self newVarBlock: vName) imageForm toolTip: nil action: {vName} ]].
	initialFrame varNamesMenu isEmpty ifFalse: [
		menu addLine.
		vn _ initialFrame varNamesMenu first.
		menu addIcon: (self newSetVarBlock: vn) imageForm toolTip: nil action: #setVar.
		menu addIcon: (self newChangeVarBlock: vn) imageForm toolTip: nil action: #changeVar ]."


	(choice _ menu localize; startUp "WithCaption: 'BYOB'") ifNil: [^ self].
	(choice isKindOf: Array) ifTrue: [
		block _ self newVarBlock: choice first.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	#setVar = choice ifTrue: [
		block _ self newSetVarBlock: vn.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	#changeVar = choice ifTrue: [
		block _ self newChangeVarBlock: vn.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	self perform: choice.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:05'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nestedBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].
	"(self isLambdaForm and: [ owner isKindOf: ScratchScriptsMorph]) ifTrue: [^nil]."

	^ super rootForGrabOf: aMorph
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 02:29'!
sequence
	^self body blockSequence! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 22:13'!
showValue

	| tooltip w worldBounds |

	tooltip _ (ScratchReporterToolTipMorph string: self morphToShow imageForm for: self)
		left: self right;
		bottom: self top.
	ScratchTranslator isRTL ifTrue: [tooltip right: self left].

	w _ self world.
	w addMorphFront: tooltip.
	((worldBounds _ w bounds) containsRect: tooltip bounds) ifFalse:
		[tooltip bounds: (tooltip bounds translatedToBeWithin: worldBounds)].

	self setProperty: #toolTip toValue: tooltip.
	tooltip initialCursorPoint: Sensor cursorPoint.
	tooltip startStepping.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 02:21'!
toggleAtomicity

	isAtomic _ isAtomic not! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:42'!
type
	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)

"

	^ type! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/9/2010 22:49'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #template	- a sunken variable blob that represents an externalized block variable
"

	type _ aSymbol! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
variables
	^ variables! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
variables: anOrderedCollection
	 variables _ anOrderedCollection! !


!LambdaBlockMorph methodsFor: 'private' stamp: 'jens 5/10/2010 00:17'!
updateReferencesUsing: aDictionary

	super updateReferencesUsing: aDictionary.
	parameters _ parameters collect:
		[:old | aDictionary at: old ifAbsent: [old]].
	variables _ variables collect:
		[:old | aDictionary at: old ifAbsent: [old]].
	declarations _ declarations collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !


!LambdaBlockMorph methodsFor: 'Enchanting' stamp: 'JM 10/18/2011 15:33'!
createShortNamesForScriptVariables: aNumber

	"We shouldn't traverse any deeper here, just return the current depth"
	^ aNumber

! !

!LambdaBlockMorph methodsFor: 'Enchanting' stamp: 'JM 10/18/2011 14:29'!
exportCodeWith: anExporter

	anExporter exportLambdaBlock: self! !

!LambdaBlockMorph methodsFor: 'Enchanting' stamp: 'JM 10/24/2011 11:54'!
lambdaBlocks

	"return ourself"
	^ OrderedCollection with: self.! !
